package inheritance;

import java.awt.Color;
import java.awt.HeadlessException;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

/**
 * By inheriting JFrame we get ** A LOT ** of code to use
 *
 * @author hajo
 */
public class MyFrame extends JFrame {

    // Adding an instance variable
    String myText = "thisIsAnExtensionToTheSuperclass";

    // Adding a method
    public final void myMethod() {
        System.out.println(myText);
    }

    public MyFrame(String title) throws HeadlessException {
        // Constructor for JFrame
        super(title);
        useSuperClassMethods();
        myMethod();
    }

    private void useSuperClassMethods() {
        // Methods are all from super class JFrame
        setSize(400, 400);
        setLocationRelativeTo(null); // Center topleft corner
        setResizable(false);
        setBackground(Color.MAGENTA); // Hmm? Strange behavior, doesn't matter
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE); // Else will run invisible
        setVisible(true);  // Draw on screen..!!!

        System.out.println(getForeground());
        System.out.println(getHeight());
        System.out.println(getWidth());
    }

    public static void main(String args[]) {
        // Create an object (will live because this is a graphical program)
        new MyFrame("Extending JFrame");
    }
}
