package inheritance.typesystem;


import java.util.List;
import java.util.Random;

/**
 * A bag to pick tiles from
 *
 * @author hajo
 */
public final class TileBag {
  
    private final List<Tile> tiles;
    // To select next tile
    private final Random r = new Random();

    public TileBag(List<Tile> tiles) {
        this.tiles = tiles;
    }
  
    public Tile get() {
        if (tiles.size() > 0) {
            // Select one randomly
            int i = r.nextInt(tiles.size());
            return tiles.remove(i);
        } else {
            return null;
        }
    }

    // Parameter will come from holder
    public void add(Tile t) {
       tiles.add(t);
    }

    public boolean isEmpty() {
        return tiles.isEmpty();
    }

    public int size() {
        return tiles.size();
    }
}
