
package swing;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

/**
 * Basic usage the JButton component
 * 
 * @author hajo
 */
// This class is a listener implements ActionListener
public class ButtonPanel extends JPanel implements ActionListener {
    
    private JButton btnOk = new JButton();
    
    public ButtonPanel(){
        init();
        
    }
    
    private void init() {
        
        // Some text properties
        btnOk.setText("The Text");
        btnOk.setActionCommand("action");
        btnOk.setBackground(new Color(209, 213, 45));
        btnOk.setForeground(Color.RED);
        btnOk.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
        
        
        // Must have a listener!!!
        btnOk.addActionListener(this);
        
        add(btnOk);
        setBorder(BorderFactory.createTitledBorder("Button"));
       
        
        Component c = btnOk;  // A button is a Component
    }

    /**
     * This only can handle mouse clicks
     * (no keys, no mouse moves)
     * @param e 
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        System.out.println("Mouse Clicked");
        // Get input data (we know it's button else exception)
        JButton t = (JButton) e.getSource();
        System.out.println(t.getText());
        System.out.println(t.getActionCommand());
        /*
         * Try comment out
         */
        // Will not respond to mouse clicks
        //txt.setEnabled(false);
        
        // A button is a JComponent
        JComponent c = btnOk;
     }
  
}
