package swing;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * Using LayoutManagers (no event handling)
 *
 * @author hajo
 */
public class LayoutPanel extends JPanel {

    private JTextField txtInput = new JTextField();

    public LayoutPanel() {
        setBorder(BorderFactory.createTitledBorder("Layout"));
        setLayout(new GridLayout(2, 2));
        add(createGridPanel());
        add(createBorderPanel());
    }

    private JPanel createGridPanel() {
        JPanel gridPanel = new JPanel();
        gridPanel.setLayout(new GridLayout(3, 3, 0, 0)); // Rows, cols, xgap, ygap
        for (int row = 0; row < 3; row++) {
            for (int col = 0; col < 3; col++) {
                JTextField t = new JTextField(row + ":" + col);
                gridPanel.add(t);
            }
        }
        gridPanel.setBorder(BorderFactory.createLineBorder(Color.RED));
        return gridPanel;
    }

    private JPanel createBorderPanel() {
        JPanel borderPanel = new JPanel();
        borderPanel.setLayout(new BorderLayout());
        borderPanel.add(new JButton("Center"), BorderLayout.CENTER);
        borderPanel.add(new JButton("North"), BorderLayout.NORTH);
        borderPanel.add(new JButton("East"), BorderLayout.EAST);
        borderPanel.add(new JButton("West"), BorderLayout.WEST);
        borderPanel.add(new JButton("South"), BorderLayout.SOUTH);
        borderPanel.setBorder(BorderFactory.createLineBorder(Color.BLUE));
        return borderPanel;
    }
}
