/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package swing;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * If listening to mouse clicks the text field must have an mouse listener: If
 * using
 *
 * ...extends JFrame implements MouseListener { ...
 *
 * then we have to implement 5 method! But we only need one (for double clicks).
 * So we instead use a special mouse adapter
 *
 * @author hajo
 */
// This class is a listener implements ActionListener
public class TextFieldMouseListenerPanel extends JPanel {

    private JTextField txtInput = new JTextField();

    public TextFieldMouseListenerPanel() {
        init();
    }

    private void init() {
        // Some text properties
        txtInput.setColumns(10);
        txtInput.setBackground(new Color(209, 255, 218));

        // Must have a listener!!!
        txtInput.addMouseListener(mouseListener);
        add(new JLabel("Double click in textfield"));
        add(txtInput);
        setBorder(BorderFactory.createTitledBorder("MouseListener"));
   
    }
    // mouseListener is is an object with type: Unnamned subtype of MouseAdapter
    // We create the subclass "on the fly" inside another (enclosing) class
    // using new as usual (this will create an extra class-file with a $ in the name)
    MouseAdapter mouseListener = new MouseAdapter() {
        // Just listen to mouse, no keyboard strokes
        @Override
        public void mouseClicked(MouseEvent e) {
            // Listen for double clicks
            if (e.getClickCount() >= 2) {
                System.out.println("Mouse double clicked");
                // Get input data (we know it's text field else exception)
                JTextField t = (JTextField) e.getSource();
                System.out.println(t.getText());
                /*
                 * Try comment out one at a time and run
                 */
                // Will respond to key clicks
                // txt.setEditable(false);

                // Will *ALSO* respond to key clicks!!!          
                // txt.setEnabled(false);
                /*
                 * Have to manually check if enabled
                 * Beginning of method add
                 * if( !t.isEnabled() ){
                 *    return;
                 * }
                 */
            }
        }
    };
}
