package swing;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

/**
 * Basic usage the JTextField component
 *
 * @author hajo
 */
// This class is a listener implements ActionListener
public class TextFieldPanel extends JPanel implements ActionListener {

    private JTextField txtInput = new JTextField();

    public TextFieldPanel() {
        init();
    }

    private void init() {
       
        // Some text properties
        txtInput.setColumns(10);
        txtInput.setBackground(new Color(209, 255, 218));

        // Must have a listener!!!
        txtInput.addActionListener(this);

        add(new JLabel("Enter text and press return"));
        add(txtInput);
        setBorder(BorderFactory.createTitledBorder("TextField"));
        Component c = txtInput;  // A button is a Component
    }

    /**
     * This only can handle Enter strokes (no other keys, no mouse) Listener is
     * the JFrame the text field is on (possible other JPanel)
     *
     * @param e
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        System.out.println("Enter key pressed");
        // Get input data (we know it's text field else exception)
        JTextField t = (JTextField) e.getSource();
        System.out.println(t.getText());
        /*
         * Try comment out one at a time and run
         */
        // Will respont to Enter key
        // txt.setEditable(false);
        // Will not respond to EnterKey
        // txt.setEnabled(false);

        // A text field is a JComponent
        JComponent c = txtInput;
    }

}
