package swing;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

/**
 * Basic usage the JToggleButton component
 *
 * @author hajo
 */
// Thsi class is a listener implements ActionListener
public class ToggleButtonPanel extends JPanel implements ActionListener {

    private JToggleButton tglbtnSelect = new JToggleButton();

    public ToggleButtonPanel() {
        init();
    }

    private void init() {
        // Some text properties
        tglbtnSelect.setText("The Text");
        tglbtnSelect.setActionCommand("action");
        tglbtnSelect.setBackground(new Color(45, 190, 233));
        tglbtnSelect.setForeground(Color.RED);

        // Must have a listener!!!
        tglbtnSelect.addActionListener(this);

        add(tglbtnSelect);
        setBorder(BorderFactory.createTitledBorder("ToggleButton"));

        Component c = tglbtnSelect;  // A toggle button is a Component
    }

    /**
     * This only can handle mouse clicks (no keys, no mouse moves) Listener is
     * the JFrame the button is on (possible other JPanel)
     *
     * @param e
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        System.out.println("Mouse Clicked");
        // Get input data (we know it's toggle button else exception)
        JToggleButton t = (JToggleButton) e.getSource();
        System.out.println(t.getText());
        System.out.println(t.getActionCommand());

        System.out.println(t.isSelected());
        /*
         * Try comment out
         */
        // Will not respond to mouse clicks
        //txt.setEnabled(false);

        // A toggle button is a JComponent
        JComponent c = tglbtnSelect;
    }
}
